require 'openssl'
require 'base64'

module Listo
  class Certificate < SimpleDelegator
    def initialize(cert_file)
      cert_der = File.read(cert_file)
      cert     = OpenSSL::X509::Certificate.new(cert_der)

      super(cert)
    end

    def to_der64
      Base64.strict_encode64(to_der)
    end
  end
end
