require 'listo/connection'
require 'listo/invoicing'
require 'listo/certificate'
require 'listo/pkey'

module Listo
  class Client
    attr_reader :connection, :cert, :pkey

    attr_accessor(
      :token,
      :cert_file,
      :pkey_passphrase,
      :pkey_file,
      :debug_mode,
    )

    def self.current
      @client
    end

    def self.configure(&config)
      yield @client = new

      @client
    end

    def cert
      @cert ||= Listo::Certificate.new(cert_file)
    end

    def pkey
      @pkey ||= Listo::PKey.new(pkey_file, pkey_passphrase)
    end

    def connection
      Listo::Connection.new(token, debug_mode: debug_mode)
    end
  end
end
