module Listo
  module Error
    class Error < StandardError
    end

    class ClientError < Error
      attr_reader :status, :headers, :body

      def initialize(env)
        @status  = env.dig(:status)
        @headers = env.dig(:headers)
        @body    = env.dig(:body)

        super("the server responded with status #{@status}")
      end
    end

    class StampError < Error
    end

    class CancelError < Error
    end
  end
end
