require 'faraday'
require 'listo/error'

module Listo
  module Middleware
    class RaiseError < Faraday::Response::Middleware
      ClientErrorStatuses = 400...600

      def on_complete(env)
        case env[:status]
        when ClientErrorStatuses
          raise Listo::Error::ClientError, response_values(env)
        end
      end

      private

      def response_values(env)
        {
          status:  env.status,
          headers: env.response_headers,
          body:    env.body
        }
      end
    end
  end
end
