require 'openssl'

module Listo
  class PKey < SimpleDelegator
    def initialize(pkey_file, pass_phrase = nil)
      @key_der = File.read(pkey_file)
      pem = pem(@key_der, pass_phrase)

      super(OpenSSL::PKey::RSA.new(pem, pass_phrase))
    end

    def pem(key_der, pass_phrase)
      _key_der = []
      _key_der << "-----BEGIN ENCRYPTED PRIVATE KEY-----"
      _key_der += Base64.strict_encode64(key_der).scan(/.{1,64}/)
      _key_der << "-----END ENCRYPTED PRIVATE KEY-----"

      _key_der = _key_der.join("\n")

      OpenSSL::PKey::RSA.new(_key_der, pass_phrase)
    end

    def base64
      Base64.encode64(@key_der).delete("\n")
    end
  end
end
